
;##########################################################################

;Dialog with Timer - DednDave, 3-2012

;##########################################################################

        INCLUDE    \masm32\include\masm32rt.inc

;##########################################################################

DlgProc    PROTO :HWND,:UINT,:WPARAM,:LPARAM

;##########################################################################

IDD_DLG  EQU 100
IDC_STXT EQU 101
IDC_BTN1 EQU 102
IDT_TIME EQU 110
IDI_ICON EQU 120

TIMER_ELAPSE EQU 1000 ;time in milliseconds

;##########################################################################

        .DATA

szTitle db ' Dialog With Timer',0

;**************************************************************************

        .DATA?
        ALIGN   4

hInstance     dd ?
hDialog       dd ?
hStxt         dd ?
hBtn1         dd ?
hIcon         dd ?
hbrBackground dd ?
rgbBgColor    dd ?

;##########################################################################

        .CODE

;**************************************************************************

DlgProc PROC    hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .if uMsg == WM_COMMAND
        .if wParam == IDC_BTN1
            INVOKE  PostMessage,hDlg,WM_SYSCOMMAND,SC_CLOSE,NULL
        .endif

    .elseif uMsg == WM_TIMER
        call    NewBgColor

    .elseif uMsg == WM_CTLCOLORDLG
        mov     eax,hbrBackground
        ret

    .elseif uMsg == WM_CTLCOLORSTATIC
        mov     eax,lParam
        .if eax == hStxt
            INVOKE  SetBkColor,wParam,rgbBgColor
            mov     eax,hbrBackground
            ret
        .endif

    .elseif uMsg == WM_INITDIALOG
        mov     eax,hDlg
        mov     hDialog,eax
        INVOKE  SendMessage,eax,WM_SETTEXT,0,offset szTitle
        INVOKE  LoadIcon,hInstance,IDI_ICON
        mov     hIcon,eax
        INVOKE  SendMessage,hDlg,WM_SETICON,0,eax
        INVOKE  GetDlgItem,hDlg,IDC_STXT
        mov     hStxt,eax
        INVOKE  GetDlgItem,hDlg,IDC_BTN1
        mov     hBtn1,eax
        INVOKE  SetTimer,hDlg,IDT_TIME,TIMER_ELAPSE,NULL
        call    NewBgColor

    .elseif uMsg == WM_CLOSE
        INVOKE  DeleteObject,hbrBackground
        INVOKE  EndDialog,hDlg,0

    .endif

        xor     eax,eax
        ret

DlgProc ENDP

;**************************************************************************

NewBgColor PROC

;create a new background brush with pseudo-random colors
;destroy the old brush handle if it is non-zero
;force the dialog to redraw with the new color

        push    esi
        push    edi

        push    edx
        push    eax
        INVOKE  QueryPerformanceCounter,esp
        pop     esi
        pop     edx
        shr     esi,8
        mov     edi,8

NBClr0: shr     esi,1
        rcl     eax,1
        shr     esi,1
        rcl     ecx,1
        shr     esi,1
        rcl     edx,1
        sub     edi,1
        jnz     NBClr0

        mov     ah,0
        shl     eax,16
        mov     ah,cl
        mov     al,dl
        mov     rgbBgColor,eax
        INVOKE  CreateSolidBrush,eax
        mov     edx,hbrBackground
        or      edx,edx
        jz      NBClr1

        push    eax
        INVOKE  DeleteObject,edx
        pop     eax

NBClr1: mov     hbrBackground,eax
        INVOKE  InvalidateRgn,hDialog,NULL,TRUE
        INVOKE  UpdateWindow,hDialog

        pop     edi
        pop     esi
        ret

NewBgColor ENDP

;**************************************************************************

_main   PROC

        xor     edi,edi
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDD_DLG,edi,DlgProc,edi
        INVOKE  ExitProcess,eax

_main   ENDP

;##########################################################################

        END     _main

